REM
REM THIS FILE IS PART OF THE "GRUMPY WEB SERVER" PROJECT
REM http://www.viste-family.net/mateusz/grumpy/
REM
REM  Percent encoding/decoding routine
REM  Author: Mateusz Viste <mateusz@viste-family.net>
REM  Last modified: 07 Mar 2009
REM

FUNCTION TranslatePercentEnc(RawString AS STRING, RevEnc AS BYTE = 0) AS STRING
  REM   RevEnc accepts 3 possible values:
  REM     0 - Decode the provided %encoded string
  REM     1 - %-Encode the provided text string
  REM     9 - Tell me how many %encoded chars in the provided string you're unable to decode
  DIM EncodePerc(1 TO 23) AS STRING => {"%20","%21","%23","%24","%25","%26","%27","%28","%29","%2A","%2B","%2C","%2F","%3A","%3B","%3C","%3D","%3E","%3F","%40","%5B","%5D"}
  DIM EncodeText(1 TO 23) AS STRING => {" ",  "!",  "#",  "$",  "%",  "&",  "'",  "(",  ")",  "*",  "+",  ","  ,"/",  ":",  ";",  "<",  "=",  ">",  "?",  "@",  "[",  "]"}

  ' Used for decoding only:
  DIM DecodeAddPerc(1 TO 4) AS STRING => {"%2E","%5F","%2D","%7E"}
  DIM DecodeAddText(1 TO 4) AS STRING => {".",  "_",  "-",  "~"}

  DIM AS STRING Wynik
  DIM AS INTEGER x, y, JobDone, NotDecoded = 0
  Wynik = RawString

  x = INSTR(Wynik, "+")
  WHILE x > 0 AND RevEnc = 0    ' Decode any "+" char as a space
    Wynik = MID(Wynik, 1, x - 1) + " " + MID(Wynik, x + 1)
    x = INSTR(Wynik, "+")
  WEND


  IF RevEnc = 1 THEN  ' Encoding
      FOR x = 1 TO LEN(Wynik)
        FOR y = 1 TO UBOUND(EncodePerc)
          IF MID(Wynik, x, 1) = EncodeText(y) THEN Wynik = MID(Wynik, 1, x - 1) + EncodePerc(y) + MID(Wynik, x + 1): EXIT FOR
        NEXT y
      NEXT x
    ELSE  ' Decoding
      IF INSTR(Wynik, "%") > 0 THEN ' Do not check if no "%" in the string
        x = 0
        DO
          x += 1
          IF MID(Wynik, x, 1) = "%" THEN
            JobDone = 0
            y = 1
            WHILE y <= UBOUND(EncodePerc) AND JobDone = 0
              IF MID(Wynik, x, 3) = EncodePerc(y) THEN Wynik = MID(Wynik, 1, x - 1) & EncodeText(y) & MID(Wynik, x + 3): JobDone = 1
              y += 1
            WEND
            y = 1
            WHILE y <= UBOUND(DecodeAddPerc) AND JobDone = 0
              IF MID(Wynik, x, 3) = DecodeAddPerc(y) THEN Wynik = MID(Wynik, 1, x - 1) & DecodeAddText(y) & MID(Wynik, x + 3): JobDone = 1
              y += 1
            WEND
            IF JobDone = 0 THEN NotDecoded += 1
          END IF
        LOOP UNTIL x >= LEN(Wynik) - 1
      END IF
  END IF

  IF RevEnc = 9 THEN RETURN TRIM(STR(NotDecoded)) ELSE RETURN Wynik
END FUNCTION
